//+------------------------------------------------------------------+
//|        Dynamic Fibonacci Grid (SciMod) + BB Candle.mq4           |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern int   Shift         = -197;
extern int   Spacing       = 50;
extern int   Width         = 49;
extern int   MA_mode       = 0;
input int    Range_in_pips = 30;
extern int   gap           = 10;

extern int BBShift = -209;
extern int BBWidth = 10;

input color TailCol = clrGray;
input color BullCol = clrYellow;
input color BearCol = clrYellow;
input color OBCol = clrFireBrick;
input color OSCol = clrGreen;

extern bool D1_Show_Line=true;
extern bool D1_Show_Price=true;
input color D1_Highcol = FireBrick;
input color D1_Lowcol = Green;
input int D1_style = 2;
extern bool Show_Daily_Info=true;

//extern int   Shiftx         = -220;
//extern int   Widthx         = 300;

#define NSL    10       // number of shade levels
#define NSVR   17      // number of solid vertical lines
#define NMA    7       // number of MAs, change ma_period[NMA-1] accordingly 
#define NTF    4       // number of time frames/lanes, change tfp[NTF] accordinlgy

double   fml[NTF][NMA];                                    // momentum lines
double   bsl_up[NTF][NSL];                                 // color shades levels to the up side
double   bsl_down[NTF][NSL];                               // color shades levels to the down side
double   bsl[NSL];                                         // color shades distances ('point' adjusted)
double   srl[28];                                          // support/resistance levels (total = 2*NSL + NMA + 1(Bid) )
double   price, average1, average2, point;
double   tmpArray[NMA], lowestMA, highestMA;
int      srgap, tfc, mac;                                  // color shades distances
int      _bsl[NSL]    = {10, 16, 26, 42, 68, 111, 179, 290, 470, 760}; // time shades distance : 9, 16, 26, 42, 68, 110, 178, 246
int      ma_period[7] = {21,34,55,75,100,144,233};         // SMAs, NMA-1
int      tfp[NTF]     = {1,5,15,60};                       // Time frames/lanes - in minutes. Like H4=240, D1=1440 etc...
int      counted_bars, startBar, bar, i, y;
int      tf, c, offset, xUnit;
int      shift, spacing, width, supports, resistances, shiftx, widthx, BBshift,BBwidth;;
color    Shade[NSL]    = {C'200,240,255', C'160,220,255', C'120,200,255', C'80,180,255', C'40,140,255', C'20,100,255', C'0,60,240', C'0,40,220', C'0,20,200'};
color    col, macolor;
string   objName, dir, MA, name;
string   uniqueid = "FXG: ";
datetime curTime;
double   PipPoints;

double Pointx;
double divider;
int x_digits;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   xUnit   = Period() * 60;
   shift   = Shift * xUnit;
   spacing = Spacing * xUnit;
   width   = Width * xUnit;
   BBshift = BBShift * xUnit;
   BBwidth = BBWidth * xUnit;
   
//   shiftx   = Shiftx * xUnit;
//   widthx   = Widthx * xUnit;
   
   point   = 0.01;
   if(Digits > 3) point = 0.0001;
   
   if(Digits==3 || Digits==5)
      {
      PipPoints=Point*10;
      }
   else
      {
      PipPoints=Point;
      }
      
   //Spread: Check for 3 & 5 digit
   if (Point == 0.00001) Pointx = 0.0001; //5 digits
   else if (Point == 0.001) Pointx = 0.01; //3 digits
   else Pointx = Point; //Normal
  
   if (Pointx > Point)
      {
      divider = 10.0;
      x_digits = 1;
      }
   else 
      {
      divider = 1;
      x_digits = 0;
      }
         
   ChartSetInteger(0,CHART_SCALEFIX,true);
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE,false);
   ChartSetDouble(0,CHART_FIXED_MAX,(Bid+(Range_in_pips*PipPoints)));
   ChartSetDouble(0,CHART_FIXED_MIN,(Bid-(Range_in_pips*PipPoints)));

//+------------------------------------------------------------------+
//| creating the objects for drawing the grid                        |
//+------------------------------------------------------------------+

   for(i=0; i<NSL; i++)  bsl[i] = _bsl[i]*point;
   for(tf=0; tf<NTF; tf++)
   {
      for(i=0; i<NSL; i++)
      {
         objName = uniqueid + "bsl_up_rect_" + tf + "_" + i;          // upper zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Shade[i]);
            
         objName = uniqueid + "ext_bsl_up_rect_" + tf;            // external upper zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, C'255,255,255');
            
         objName = uniqueid + "bsl_down_rect_" + tf + "_" + i;        // lower zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Shade[i]);
            
         objName = uniqueid + "ext_bsl_down_rect_" + tf;          // external lower zones
         ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, C'255,255,255');
            
         objName = uniqueid+"bsl_up_bar_"+tf+"_"+i;           // upper zone separator lines
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, clrBlack);
            
         objName = uniqueid+"bsl_down_bar_"+tf+"_"+i;         // lower zone separator lines
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, clrBlack);

      }

      objName = uniqueid + "MidShade_" + tf;                      // price zone
      ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_COLOR, C'255,255,255');

      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fml_bar_" + tf + "_" + i;              // horizontal momentum lines
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);

            ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);
            ObjectSet(objName, OBJPROP_COLOR, Black);
            ObjectSetInteger(NULL,objName,OBJPROP_FONTSIZE,7);
            ObjectSet(objName, OBJPROP_WIDTH, 0);
         if(i<2 || i == NMA-1)
            ObjectSet(objName, OBJPROP_WIDTH, 1);
      }

      for(i=1; i<=NSVR; i++)
      {
         objName = uniqueid + "svr_" + tf + "_" + i;              // solid vertical lines (10 pips or more)
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_RAY, false);
         ObjectSet(objName, OBJPROP_WIDTH, 3);
            
         objName = uniqueid + "ext_up_svr_" + tf;                 // extern upper vertical lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_RAY, false);
         ObjectSet(objName, OBJPROP_WIDTH, 3);
            
         objName = uniqueid + "ext_down_svr_" + tf;               // extern lower vertical lines
         ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSet(objName, OBJPROP_RAY, false);
         ObjectSet(objName, OBJPROP_WIDTH, 3);
      }
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   ObjectDelete("Bid");
  // ObjectDelete("Bidx");
  
   ObjectDelete(0,"MA_21");      
   ObjectDelete(0,"SMA_21_DIS");
   ObjectDelete(0,"BBHigh_Area_0");
   ObjectDelete(0,"BBLow_Area_0");
   ObjectDelete(0,"BBHigh_Area");
   ObjectDelete(0,"BBLow_Area");
   
   ObjectDelete("High_line");   
   ObjectDelete("Low_line");    
   ObjectDelete("High_price");   
   ObjectDelete("Low_price"); 

   ObjectDelete("D1Range");   
   ObjectDelete("D1Change"); 
      
   string lookFor       = uniqueid;
   int    lookForLength = StringLen(lookFor);   
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i);
         if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int X = -10, Y = 15, A = 10, B = 12;
   point   = 0.01;
   if(Digits > 3) point = 0.0001;
   
   ChartSetInteger(0,CHART_SCALEFIX,true);
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE,false);
   ChartSetDouble(0,CHART_FIXED_MAX,(Bid+(Range_in_pips*PipPoints)));
   ChartSetDouble(0,CHART_FIXED_MIN,(Bid-(Range_in_pips*PipPoints)));
   
      ObjectDelete("Bid");
   ObjectCreate(0,"Bid",OBJ_HLINE,0,0,Bid);
   ObjectSet("Bid",OBJPROP_STYLE,5);
   ObjectSet("Bid",OBJPROP_COLOR,clrBlack);
   ObjectSet("Bid",OBJPROP_SELECTABLE,false);
/*   
   ObjectDelete("Bidx");
   ObjectCreate(0,"Bidx",OBJ_TREND,0,0,0,0);
   ObjectSet("Bidx",OBJPROP_TIME1,curTime+shiftx);
   ObjectSet("Bidx",OBJPROP_TIME2,curTime+shiftx+widthx);
   ObjectSet("Bidx",OBJPROP_PRICE1,Bid);
   ObjectSet("Bidx",OBJPROP_PRICE2,Bid);
   ObjectSet("Bidx",OBJPROP_STYLE,0);
   ObjectSet("Bidx",OBJPROP_COLOR,clrBlack);
   ObjectSet("Bidx",OBJPROP_RAY,false);
*/   
//+------------------------------------------------------------------+
//| Time lines                                                       |
//+------------------------------------------------------------------+

   int short_gap_count;
   int long_gap_count;
   int sr_short_gap_count;
   int sr_long_gap_count;
   curTime = Time[1]; 
   price   = Close[0];
    
   for(tf=0; tf<NTF; tf++)
   {
      bar = iBarShift(NULL, tfp[tf], curTime, false);
      for(i=0; i<NMA; i++)  fml[tf][i] = iMA(NULL, tfp[tf], ma_period[i], 0, MA_mode, PRICE_CLOSE, bar/Period());  // populating the fml array...
      for(i=0; i<NMA; i++) tmpArray[i] = fml[tf][i];                                                               // finding the highest and lowest MAs from the (7) fml's/MA's
      ArraySort(tmpArray);                                                                                         // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
         lowestMA  = tmpArray[0];
         highestMA = tmpArray[6];

      for(i=0; i<NSL; i++)                                                                                         // populating the bsl arrays...
      {
         bsl_up[tf][i]   = lowestMA  + bsl[i];
         bsl_down[tf][i] = highestMA - bsl[i];
      }
   }

//+------------------------------------------------------------------+
//| drawing the color shades of the grid from top to bottom          |
//+------------------------------------------------------------------+

   for(tf=0; tf<NTF; tf++) 
   {
      offset = 0;                                                                // find the number of overlapping shades
      for(i=offset; i<NSL-1; i++) if(bsl_up[tf][i] <= bsl_down[tf][i]) offset++;

      if(offset > 0)                                                             // hide first level objects' overlapping, so they wont be left as 'ghosts'
      {
         objName = uniqueid + "bsl_up_rect_" + tf + "_" + (NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1,  0);
            ObjectSet(objName, OBJPROP_TIME2,  0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
            
         objName = uniqueid + "bsl_down_rect_" + tf + "_" + (NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1,  0);
            ObjectSet(objName, OBJPROP_TIME2,  0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

      }
        
      double highest=0;
      for(i=NSL-2; i>=offset; i--)
      {
         objName = uniqueid + "bsl_up_rect_" + tf + "_" + (i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i+1]);
                
         if (bsl_down[tf][i]>highest) highest=bsl_up[tf][i+1];
            
         objName = uniqueid+"bsl_up_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+6*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSetInteger(0,objName,OBJPROP_ANCHOR,1);
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,8);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
            if (bsl_up[tf][i] <10) ObjectSetText(objName, DoubleToString(bsl_up[tf][i],4));
            else ObjectSetText(objName, DoubleToString(bsl_up[tf][i],2));
            
      }

      double lowest=9999.9999;
      for(i=0; i<NSL-1; i++)
      {
         objName = uniqueid + "bsl_down_rect_" + tf + "_" + (i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i+1]);
         
         if(bsl_down[tf][i]<lowest) lowest=bsl_down[tf][i+1];
            
            objName = uniqueid+"bsl_down_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+6*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSetInteger(0,objName,OBJPROP_ANCHOR,1);
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,8);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
            if (bsl_down[tf][i] <10) ObjectSetText(objName, DoubleToString(bsl_down[tf][i],4));
            else ObjectSetText(objName, DoubleToString(bsl_down[tf][i],2));

      }

      objName = uniqueid + "MidShade_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
         ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][offset]);
         ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][offset]);
      
      objName = uniqueid + "ext_bsl_up_rect_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
         ObjectSet(objName, OBJPROP_PRICE1, highest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());
            
      objName = uniqueid + "ext_up_svr_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, highest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());   
         ObjectSet(objName, OBJPROP_COLOR,  clrNONE);
      
      objName = uniqueid + "ext_bsl_down_rect_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+width);
         ObjectSet(objName, OBJPROP_PRICE1, lowest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
        
      objName = uniqueid + "ext_down_svr_" + tf;
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+tf*spacing+Width/2*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, lowest);
         ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
         ObjectSet(objName, OBJPROP_COLOR,  clrNONE);

//+------------------------------------------------------------------+
//| drawing the momentum lines bars                                  |
//+------------------------------------------------------------------+

      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fml_bar_" + tf + "_" + i;
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+6*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fml[tf][i]);
            //double original = fml[tf][i]+Point()*1000;
            //double rounded = NormalizeDouble(fml[tf][i],2);
            //double actual = (original-rounded)/(Point()*10);
            //if (original-rounded<10) actual = original-rounded;
            //if (original-rounded>10) actual = original-Point*100-rounded;
            //double labelDouble = actual/(Point()*10);
            //if (labelDouble >= 100) labelDouble=labelDouble-100;
            //if (labelDouble < 10) labelString = "0"+DoubleToString(labelDouble,0);
            //if (labelDouble >= 10) labelString=DoubleToString(labelDouble,0);

            

         if(i==1 || i==0){
            if(fml[tf][i] >= price) col = FireBrick;
            else                    col = ForestGreen;
            ObjectSet(objName, OBJPROP_COLOR, col);
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,9);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Marlett");
            ObjectSetText(objName,"g");
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+3*xUnit);

            ObjectCreate(0,objName+"text",OBJ_TEXT,0,0,0,0);
            ObjectSet(objName+"text", OBJPROP_COLOR, Black);
            ObjectSetInteger(0,objName+"text",OBJPROP_ANCHOR,1);
            ObjectSetInteger(NULL,objName+"text", OBJPROP_FONTSIZE,7);
            ObjectSetString(NULL,objName+"text", OBJPROP_FONT, "Arial");
            string labelString0;
            if (fml[tf][i]<10) labelString0 = DoubleToString(fml[tf][i],4)+"-L"+(i+1);
            else labelString0 = DoubleToString(fml[tf][i],2)+"-L"+(i+1);
            ObjectSet(objName+"text", OBJPROP_TIME1,  curTime+shift+tf*spacing+6*xUnit);
            ObjectSet(objName+"text", OBJPROP_PRICE1, fml[tf][i]);
            ObjectSetText(objName+"text", labelString0);
            
            
            
         }
         if(i==6){
            col = Black;
            ObjectSet(objName, OBJPROP_COLOR, col);
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,9);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Marlett");
            ObjectSetText(objName,"g");
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+3*xUnit);

            ObjectCreate(0,objName+"text",OBJ_TEXT,0,0,0,0);
            ObjectSet(objName+"text", OBJPROP_COLOR, Black);
            ObjectSetInteger(0,objName+"text",OBJPROP_ANCHOR,1);
            ObjectSetInteger(NULL,objName+"text", OBJPROP_FONTSIZE,7);
            ObjectSetString(NULL,objName+"text", OBJPROP_FONT, "Arial");
            string labelString6;
            if (fml[tf][i]<10) labelString6 = DoubleToString(fml[tf][i],4)+"-L"+(i+1);
            else labelString6 = DoubleToString(fml[tf][i],2)+"-L"+(i+1);
            ObjectSet(objName+"text", OBJPROP_TIME1,  curTime+shift+tf*spacing+6*xUnit);
            ObjectSet(objName+"text", OBJPROP_PRICE1, fml[tf][i]);
            ObjectSetText(objName+"text", labelString6);
         }
         else if (i<6 && i>1){
            ObjectSetInteger(0,objName,OBJPROP_ANCHOR,1);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial");
            string labelString;
            if (fml[tf][i]<10) labelString = DoubleToString(fml[tf][i],4)+"-L"+(i+1);
            else labelString = DoubleToString(fml[tf][i],2)+"-L"+(i+1);
            ObjectSetText(objName, labelString);
         }
      }

//+------------------------------------------------------------------+
//| drawing the solid vertical lines                                 |
//+------------------------------------------------------------------+      

      ArrayInitialize(srl, -1);
      for (i=0; i<NMA; i++) srl[i] = fml[tf][i];
      for (i=offset; i<NSL; i++)
      {
         srl[NMA+i] = bsl_down[tf][i];
         srl[NMA+NSL+i] = bsl_up[tf][i];
      }
      
      srl[NMA+2*NSL] = price;
      ArraySort(srl);

      c           = 0;          // looking for a gap of 10 pips or more
      supports    = 0;
      resistances = 0;
      for(i=0; i<NMA+2*NSL+2; i++)
      {
         if(srl[i] > price) resistances++;
         if(srl[i] < price) supports++;
         if(-1 == srl[i])
            continue;
         if(srl[i+1]-srl[i] >= gap*point)
         {
            c++;
            objName = uniqueid + "svr_" + tf + "_" + c;
               ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+Width/2*xUnit);
               ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+Width/2*xUnit);
               ObjectSet(objName, OBJPROP_PRICE1, srl[i]+ Point()*9);
               ObjectSet(objName, OBJPROP_PRICE2, srl[i+1]-Point()*9);

            if (srl[i+1] <= price)
            {
               if(price==srl[i+1]) short_gap_count++;
               ObjectSet(objName, OBJPROP_COLOR, FireBrick);
            }
            else
            {
               if(price==srl[i]) long_gap_count++;
               ObjectSet(objName, OBJPROP_COLOR, Green);
            }
         }
         
         if (srl[i+1]-srl[i] >= srgap*point)
         {
            if(srl[i+1] <= price)
               if(price==srl[i+1]) sr_short_gap_count++;
               else
               if(price==srl[i])   sr_long_gap_count++;
         }

      }
      
      if(supports == 0) 
      {
         sr_short_gap_count++;
         short_gap_count++;
      }
      
      if(resistances == 0) 
      {
         sr_long_gap_count++;
         long_gap_count++;
      }

      if(c >= NSVR) Print("Warning: NSVR exceeded");
      else  // hide the unused vertical lines objects so they wont be left as 'ghosts' (only the first)
      {
         objName = uniqueid + "svr_" + tf + "_" + (c+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
      }
   }
//---------------------------------------------------------------------------------

   double SMA_21 = iMA(0,PERIOD_M1,21,0,0,0,0);    
   double BB_Up = iBands(NULL,PERIOD_M1,21,2,0,PRICE_CLOSE,1,0);
   double BB_Down = iBands(NULL,PERIOD_M1,21,2,0,PRICE_CLOSE,2,0);
   
//-------------------------
   
   ObjectDelete("MA_21");
   ObjectCreate(0,"MA_21",OBJ_TREND,0,0,0,0);
   ObjectSet("MA_21", OBJPROP_TIME1,  curTime+BBshift);
   ObjectSet("MA_21", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
   ObjectSet("MA_21", OBJPROP_PRICE1, SMA_21);
   ObjectSet("MA_21", OBJPROP_PRICE2, SMA_21);
   ObjectSet("MA_21",OBJPROP_STYLE,0);
   ObjectSet("MA_21",OBJPROP_COLOR,clrBlack);
   ObjectSet("MA_21",OBJPROP_RAY,false);   
   
   ObjectDelete(0,"SMA_21_DIS");
   ObjectCreate(0,"SMA_21_DIS",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("SMA_21_DIS", OBJPROP_TIME1,  curTime+BBshift);
   ObjectSet("SMA_21_DIS", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
   ObjectSet("SMA_21_DIS", OBJPROP_PRICE1, SMA_21 );
   ObjectSet("SMA_21_DIS", OBJPROP_PRICE2, Bid );
   if(Bid>BB_Up)ObjectSet("SMA_21_DIS", OBJPROP_PRICE2, BB_Up);   
   if(Bid<BB_Down)ObjectSet("SMA_21_DIS", OBJPROP_PRICE2, BB_Down);
   color bodyCol;
   if(Bid>SMA_21)bodyCol=BullCol;
   if(Bid<SMA_21)bodyCol=BearCol;
   ObjectSet("SMA_21_DIS", OBJPROP_COLOR,  bodyCol );  

   ObjectDelete(0,"BBHigh_Area_0");
 if (Bid<BB_Up){
   ObjectCreate(0,"BBHigh_Area_0",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("BBHigh_Area_0", OBJPROP_TIME1,  curTime+BBshift);
   ObjectSet("BBHigh_Area_0", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
   ObjectSet("BBHigh_Area_0", OBJPROP_PRICE1, BB_Up );
   if(Bid>SMA_21){ObjectSet("BBHigh_Area_0", OBJPROP_PRICE2, Bid );}
   if(Bid<SMA_21){ObjectSet("BBHigh_Area_0", OBJPROP_PRICE2, SMA_21 );}   
   ObjectSet("BBHigh_Area_0", OBJPROP_COLOR,  TailCol);  
   }
   
   ObjectDelete(0,"BBLow_Area_0");
 if (Bid>BB_Down){
   ObjectCreate(0,"BBLow_Area_0",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("BBLow_Area_0", OBJPROP_TIME1,  curTime+BBshift);
   ObjectSet("BBLow_Area_0", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
   ObjectSet("BBLow_Area_0", OBJPROP_PRICE1, BB_Down );
   if(Bid<SMA_21){ObjectSet("BBLow_Area_0", OBJPROP_PRICE2, Bid );}
   if(Bid>SMA_21){ObjectSet("BBLow_Area_0", OBJPROP_PRICE2, SMA_21 );}   
   ObjectSet("BBLow_Area_0", OBJPROP_COLOR,  TailCol);  
   }
//----
    
   ObjectDelete(0,"BBHigh_Area");
 if (Bid>BB_Up){
   ObjectCreate(0,"BBHigh_Area",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("BBHigh_Area", OBJPROP_TIME1,  curTime+BBshift);
   ObjectSet("BBHigh_Area", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
   ObjectSet("BBHigh_Area", OBJPROP_PRICE1, BB_Up );
   ObjectSet("BBHigh_Area", OBJPROP_PRICE2, Bid );
   ObjectSet("BBHigh_Area", OBJPROP_COLOR,  OBCol);  
   }
   
   ObjectDelete(0,"BBLow_Area");
 if (Bid<BB_Down){
   ObjectCreate(0,"BBLow_Area",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("BBLow_Area", OBJPROP_TIME1,  curTime+BBshift);
   ObjectSet("BBLow_Area", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
   ObjectSet("BBLow_Area", OBJPROP_PRICE1, BB_Down );
   ObjectSet("BBLow_Area", OBJPROP_PRICE2, Bid );
   ObjectSet("BBLow_Area", OBJPROP_COLOR,  OSCol);  
   }
//--------------------------------------------------------------------
//   Daily high/low

 double  D1_high=iHigh(NULL, PERIOD_D1,0); 
 double  D1_low=iLow(NULL, PERIOD_D1,0);     
   
 if (D1_Show_Line==true) 
   { 
   ObjectDelete("High_line");
   ObjectCreate(0,"High_line",OBJ_TREND,0,0,0,0);
   ObjectSet("High_line", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("High_line", OBJPROP_TIME2,  curTime+shift+spacing*4);
   ObjectSet("High_line", OBJPROP_PRICE1, D1_high);
   ObjectSet("High_line", OBJPROP_PRICE2, D1_high);
   ObjectSet("High_line",OBJPROP_STYLE,D1_style);
   ObjectSet("High_line",OBJPROP_COLOR,D1_Highcol);
   ObjectSet("High_line",OBJPROP_RAY,false);
   
   ObjectDelete("Low_line");
   ObjectCreate(0,"Low_line",OBJ_TREND,0,0,0,0);
   ObjectSet("Low_line", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Low_line", OBJPROP_TIME2,  curTime+shift+spacing*4);
   ObjectSet("Low_line", OBJPROP_PRICE1, D1_low);
   ObjectSet("Low_line", OBJPROP_PRICE2, D1_low);
   ObjectSet("Low_line",OBJPROP_STYLE,D1_style);
   ObjectSet("Low_line",OBJPROP_COLOR,D1_Lowcol);
   ObjectSet("Low_line",OBJPROP_RAY,false);
   }
   
 if (D1_Show_Price==true) 
   { 
   ObjectDelete("High_price");
   ObjectCreate(0,"High_price",OBJ_HLINE,0,0,D1_high);
   ObjectSet("High_price",OBJPROP_STYLE,5);
   ObjectSet("High_price",OBJPROP_COLOR,D1_Highcol);
   
   ObjectDelete("Low_price");
   ObjectCreate(0,"Low_price",OBJ_HLINE,0,0,D1_low);
   ObjectSet("Low_price",OBJPROP_STYLE,5);
   ObjectSet("Low_price",OBJPROP_COLOR,D1_Lowcol);
   }
//--------------------------------------------------------------------
//   Daily Info

 if (Show_Daily_Info==true)
   { 
   double  D1_open=iOpen(NULL, PERIOD_D1,0); 
   double  D1_Range=(D1_high-D1_low)/Point;
   double  D1_Change=(Bid-D1_open)/Point;
   
   color D1CCol;
   
   if (Bid > D1_open)D1CCol= clrGreen;
   if (Bid < D1_open)D1CCol= clrFireBrick;   
   
      ObjectCreate(0,"D1Range",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"D1Range",OBJPROP_CORNER,0);
   ObjectSetInteger(0,"D1Range",OBJPROP_BORDER_COLOR,C'155,155,155');
   ObjectSetInteger(0,"D1Range",OBJPROP_BGCOLOR,clrDarkGray);
   ObjectSetInteger(0,"D1Range",OBJPROP_XDISTANCE,12);
   ObjectSetInteger(0,"D1Range",OBJPROP_YDISTANCE,-1);
   ObjectSetInteger(0,"D1Range",OBJPROP_XSIZE,40);
   ObjectSetInteger(0,"D1Range",OBJPROP_YSIZE,15);
   ObjectSetInteger(0,"D1Range",OBJPROP_COLOR,Black);
   ObjectSetInteger(0,"D1Range",OBJPROP_FONTSIZE,8);
   ObjectSetString(0,"D1Range",OBJPROP_TEXT,DoubleToString(NormalizeDouble(D1_Range / divider, 1), x_digits));
   ObjectSetInteger(0,"D1Range",OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"D1Range",OBJPROP_HIDDEN,True); 
   
         ObjectCreate(0,"D1Change",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"D1Change",OBJPROP_CORNER,0);
   ObjectSetInteger(0,"D1Change",OBJPROP_BORDER_COLOR,C'155,155,155');
   ObjectSetInteger(0,"D1Change",OBJPROP_BGCOLOR,clrDarkGray);
   ObjectSetInteger(0,"D1Change",OBJPROP_XDISTANCE,52);
   ObjectSetInteger(0,"D1Change",OBJPROP_YDISTANCE,-1);
   ObjectSetInteger(0,"D1Change",OBJPROP_XSIZE,40);
   ObjectSetInteger(0,"D1Change",OBJPROP_YSIZE,15);
   ObjectSetInteger(0,"D1Change",OBJPROP_COLOR,D1CCol);
   ObjectSetInteger(0,"D1Change",OBJPROP_FONTSIZE,8);
   ObjectSetString(0,"D1Change",OBJPROP_TEXT,DoubleToString(NormalizeDouble(D1_Change / divider, 1), x_digits));
   ObjectSetInteger(0,"D1Change",OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"D1Change",OBJPROP_HIDDEN,True); 
   }
   
//----------------------------------------------------     
return(0);
}

